Merged autobuild into bldpkg, made changes related to it in bldpkg.conf

This commit is contained in:
PktSurf 2023-05-11 22:56:36 +05:30
parent 258fdc4b56
commit 64e8468718
3 changed files with 527 additions and 543 deletions

134
autobuild
View file

@ -1,134 +0,0 @@
#!/bin/bash
#
# Part of the SMLinux distribution
# http://git.pktsurf.in/smlinux
#
# autobuild version 0.100
# Bash script to automatically build section-specific packages for SMLinux
#
# Copyright (c) 2023 PktSurf <smlinux@pktsurf.in>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
############
sections=(base xorg gtk extra net xfce)
buildcleanup() {
[[ -f $autobuildtemp ]] && rm -f $autobuildtemp
exit
}
trap "buildcleanup" INT
trap "buildcleanup" EXIT
err() {
printf "**ERROR**\n$@\n"
exit 1
}
warn() {
printf "[WARN]\n$@\n"
}
info() {
printf "[INFO] $@\n"
}
parenttmp="/tmp"
autobuild=1
arch="$HOSTTYPE"
colours=0
autobuildtemp="$(mktemp $parenttmp/SMBUILD.XXXXXX)"
export parenttmp autobuild arch colours autobuildtemp
for section in "${sections[@]}" ; do
pkgdest="$parenttmp/sml/packages/$arch/$section"
logdir="$parenttmp/sml/sml-buildlogs/$arch/$section"
export section pkgdest
mkdir -p $pkgdest $logdir
if [[ ! -d $section ]] ; then
err "Section directory '$section' not found!"
fi
cd $section
# This check compares a list of source directories with the list of the
# packages in the build list and warns of any missing package names
# in either of the two.
dirtempfile=$(mktemp $parenttmp/DIRECTORYNAMES."$section".XXXXXX)
dirfiletemppath="$dirtempfile"
dirlist=$(find . -type d -maxdepth 1 -mindepth 1 | sed 's@./@@' | sort > $dirfiletemppath)
packtempfile=$(mktemp $parenttmp/BUILDFILENAMES."$section".XXXXXX)
packfiletemppath="$packtempfile"
sort .buildlist.$section > $packfiletemppath
directorycount="$( wc -l < $dirtempfile )"
buildlistcount="$( wc -l < $packtempfile )"
# Get number of total packages
totalpkgnumber="$(wc -l < .buildlist.$section)"
export totalpkgnumber
if diff -u "$dirfiletemppath" "$packfiletemppath" > /dev/null 2>&1 ; then
diffstatus="0"
else
diffstatus="1"
fi
if [ "$diffstatus" != "0" ]; then
warn "In section '"$section"', the number of packages in the hidden file '.buildlist."$section"' is different to the number of package directories. Some packages may not have been added to this file/section directory. They are listed below:"
diff -u "$dirfiletemppath" "$packfiletemppath" || true
diff -u "$packfiletemppath" "$dirfiletemppath" || true
warn "Building anyways :-) "
sleep 2
fi
rm -f $packfiletemppath $dirfiletemppath
if [[ ! -f .buildlist.$section ]] ; then
err "Section build list file '.buildlist.$section' not found!"
fi
while IFS="" read -r package || [[ -n $package ]] ; do
currentpkgnumber="$(grep -Ewn "^$package" .buildlist.$section | cut -d: -f 1)"
export currentpkgnumber
(
cd $package
source $package.SMBuild
# Check if package installer exists or is installed on the system
# If the package installer does not exist in the set pkg destination, build it
if [ ! -f $pkgdest/$app-$version-*-$build.* ] ; then
bldpkg 2>&1 | tee -a $logdir/$app-$version-$build.log.txt
# If the package is not installed in the system, install it
if [ ! -f /var/log/packages/$app-$version-*-$build ] ; then
upgradepkg --install-new $pkgdest/$app-$version-*-$build.*
else
info "'$app-$version' already installed, skipping it"
fi
elif [ ! -f /var/log/packages/$app-$version-*-$build ] ; then
upgradepkg --install-new $pkgdest/$app-$version-*-$build.*
else
info "Already built '$app-$version', skipping it"
fi
)
done < ".buildlist.$section"
cd ..
done

930
bldpkg

File diff suppressed because it is too large Load diff

View file

@ -7,6 +7,8 @@
# Please refer to sample.SMBuild.explained in the buildsamples directory
# for complete explanation.
sections=(base xorg gtk extra net xfce)
# Set the package extension. Makepkg will use this to figure out the
# compression utility. Pick one out of tbz/tgz/txz/tlz.
pkgext="tlz"
@ -109,7 +111,7 @@ nontmpfsdir="$parenttmp/sml"
# openssh-8.1-x86_64-1sml.tlz should be placed in. Again, should be outside
# tmpfs dir. Also declared and defined in autobuild section file, so values
# may differ. This is for manual builds.
pkgdest=${pkgdest:-$parenttmp/sml/packages/}
pkgdest="$parenttmp/sml/packages/"
# Whether you want to preserve the build directory which contains the extracted source,
# for example /tmp/sml/openssh.src/openssh-8.1. usetmpfs variable, if set to 1, will
@ -135,7 +137,7 @@ showsummary=1
# Define whether to check for swap. 1 to enable, 0 to disable.
swapcheck=0
# If above variable is set to 1, define minimum swap size required for huge
# If above variable is set to 1, define swap size required for huge
# compiles in KiB
swapsize=2048000